%  casteljau03.m
% fd, 17 octobre 2006, 04 mars 2025
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   clear ; format long

printf('casteljau03 : courbe de Bezier de degre 2\n') ;


n=1 ; nn=3 ; 
pt = zeros(nn , 2) ; 
hold off ;
plot(pt(1,1),pt(1,2),'*k-;;');  % pause ; 
hold on ;
m=10 ,  dth = 1 / m ; 
x1=1; y1=0; x2=0; y2=1; 
pt(1:1,1:1)=0; pt(2:2,1:1)=x1; pt(3:3,1)=x2;
pt(1:1,2:2)=0; pt(2:2,2:2)=y1; pt(3:3,2)=y2;
plot(pt(1:nn,1),pt(1:nn,2),'*k;noeuds;')
plot(pt(1:nn,1),pt(1:nn,2),'-k;polygone de controle;')
axis ( [ -.1, 1.1 , -.1 , 1.1 ]) ;
delete (findobj ("tag", "legend"))

g1 = zeros(nn-1,2) ;  g2 = zeros(nn-2,2) ; 
theta = 0 ; 
for k=1:m+1; pause (.2) ; 
for j=1:2 ; 
g1(j:j,1:2) = (1-theta)*pt(j:j,1:2)+theta*pt(j+1:j+1,1:2); end ; 
plot(g1(:,1:1),g1(:,2:2),'*r;;'); plot(g1(:,1:1),g1(:,2:2),'r;;')
 
g2(1:1,1:2) = (1-theta)*g1(1:1,1:2)+theta*g1(2:2,1:2); 
plot(g2(:,1:1),g2(:,2:2),'*r;;');
theta = theta + dth ;  
end ; 

title ('la courbe de Bezier de Casteljau apparait comme une enveloppe') ;
plot(pt(1:nn,1),pt(1:nn,2),'*k;;')
plot(pt(1:nn,1),pt(1:nn,2),'-k;;')


print('03-courbe-enveloppe', '-djpg','-S891,630'); 


