% casteljau04.m
% fd, 17 octobre 2006, 04 mars 2025
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   clear ; format long

printf('casteljau04 : courbe de Bezier de Castejau de degre 3\n') ;


n=1 ; nn=4 ; 
pt = zeros(nn , 2) ; 
hold off ;
plot(pt(1,1),pt(1,2),'*;;');  % pause ;
hold on ;
delete (findobj ("tag", "legend")) 

m=20 %% 100 ,
dth = 1 / m ; 
x1=1; y1=0; x2=0; y2=1;  x3=.5; y3=2;
pt(1:1,1:1)=0; pt(2:2,1:1)=x1; pt(3:3,1)=x2; pt(4,1)=x3;
pt(1:1,2:2)=0; pt(2:2,2:2)=y1; pt(3:3,2)=y2; pt(4,2)=y3;
plot(pt(1:nn,1),pt(1:nn,2),'*k;noeuds;')
plot(pt(1:nn,1),pt(1:nn,2),'k;polygone de controle;')
axis ( [ -.1, 1.1 , -.1 , 2.1 ]) ;

g1 = zeros(nn-1,2) ;  g2 = zeros(nn-2,2) ;  g3 = zeros(nn-3,2) ; 
theta = 0 ; 
for k=1:m+1; pause (.2) ;  for j=1:nn-1 ; 
g1(j:j,1:2) = (1-theta)*pt(j:j,1:2)+theta*pt(j+1:j+1,1:2); end ; 
plot(g1(:,1:1),g1(:,2:2),'*-r;;'); % plot(g1(:,1:1),g1(:,2:2),'g;;')
delete (findobj ("tag", "legend")) 

for j2=1:nn-2 ; 
g2(j2:j2,1:2) = (1-theta)*g1(j2:j2,1:2)+theta*g1(j2+1:j2+1,1:2); 
plot(g2(:,1:1),g2(:,2:2),'*-b;;') %% ; plot(g2(:,1:1),g2(:,2:2),'b;;')
delete (findobj ("tag", "legend")) 
end ; 
for j3=1:nn-3 ; 
g3(j3:j3,1:2) = (1-theta)*g2(j3:j3,1:2)+theta*g2(j3+1:j3+1,1:2); 
plot(g3(:,1:1),g3(:,2:2),'om;;'); end ; 
delete (findobj ("tag", "legend")) 

theta = theta + dth ;  
end ; 

title ('avec trois segments, on a une courbe polynomiale de degre 3') ;
print('04-courbe-enveloppe-trois-segments', '-djpg','-S891,630'); 




